#!/usr/bin/perl


$n_point = 20;
$react_filename_suffix = "react";
$prod1_filename_suffix = "prod1";
$prod2_filename_suffix = "prod2";


sub get_energy {
    my $filename = $_[0];
    my $ret = open FILE, $filename;
    my $res;
    my $line;
    if (!$ret) {
        die "open file error: $!";
    }
    while (defined($line = <FILE>)) {
        if ($line =~ /SCF Done/) {
            my @field = split /\s+/, $line;
            $res = $field[5];
            last;
        }
    }
    $res;
}

sub get_ref {
    my $filename = $_[0];
    my $ret = open FILE, $filename;
    if (!$ret) {
        die "open file error: $!";
    }
    my @res = ();
    while (defined(my $line = <FILE>)) {
        my @field = split /\s+/, $line;
        push(@res, $field[1]);
    }
   @res;
}

sub get_rmsd {
    my @array = @_;
    my $len = @array;
    my $res = 0;
    for $num(@array) {
        $res += ($num**2);
    }
    sqrt($res/$len);
}

sub get_msd {
    my @array = @_;
    my $len = @array;
    my $sum = 0;
    for $num(@array) { 
     $sum += $num;
    }
   $msd=$sum/$len;
}

sub get_mad {
    my @array = @_;
    my $len = @array;
    my $sum_abs = 0;
    for $num(@array) {
       if($num lt 0) {
         $num = -1 * $num;
       } else {
        $num;
       }
    }
    @array;
    
   for $num(@array) {
   $sum_abs += $num;
   }
$msd =$sum_abs/$len;
}  

@ref_values = &get_ref("Wn-F12_ref.txt");
@dev_values = ();

$i_point = 1;
open REFILE, ">RE";
open DEVFILE, ">Deviations";
while ($i_point <= $n_point) {
    print "processing point $i_point ... ";
    $renergy = &get_energy($i_point.$react_filename_suffix.".log");
    $p1energy = &get_energy($i_point.$prod1_filename_suffix.".log");
    $p2energy = &get_energy($i_point.$prod2_filename_suffix.".log");
    $reaction_energy =  ($p1energy + $p2energy - $renergy) * 2625.5;
    $dev = $reaction_energy - $ref_values[$i_point-1];
    push(@dev_values, $dev);
    printf REFILE "%12.2f\n",$reaction_energy;
    printf DEVFILE "%12.2f\n", $dev;
    print "done\n";

    $i_point++;
}

$rmsd=&get_rmsd(@dev_values);
print "The RMSD is"; 
printf "%12.2f", $rmsd;
print " kj"."/"."mol","\n";

$mad=&get_mad(@dev_values);
print "The MAD is";
printf "%12.2f",$mad;
print " kj"."/"."mol","\n";

$msd=&get_msd(@dev_values);
print "The MSD is";
printf "%12.2f",$msd;
print " kj"."/"."mol","\n";

